﻿using HogwartsSchool.Entidade;
using MySql.Data.MySqlClient;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HogwartsSchool.Repository
{
    internal class CasaRepository
    {
        private readonly string _connectionString;

        public CasaRepository(string connectionString)
        {
            _connectionString = connectionString;
        }

        public List<Casa> ObterTodasCasas()
        {
            List<Casa> casas = new List<Casa>();
            using (var connection = new MySqlConnection(_connectionString))
            {
                connection.Open();
                string query = "SELECT * FROM casa";
                using (var command = new MySqlCommand(query, connection))
                using (var reader = command.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        casas.Add(new Casa
                        {
                            IdCasa = reader.GetInt32("id_casa"),
                            Nome = reader.GetString("nome"),
                            Fundador = reader.GetString("fundador"),
                            Fantasma = reader.GetString("fantasma"),
                            Mascote = reader.GetString("mascote"),
                            IdDiretor = reader.GetInt32("id_diretor"),
                            Cor = reader.GetString("cor")
                        });
                    }
                }
            }
            return casas;
        }
    }
}
