﻿using HogwartsSchool.Entidade;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections.Generic;
using MySql.Data.MySqlClient;

namespace HogwartsSchool.Repository
{
    internal class ProfessorRepository
    {
        private readonly string _connectionString;

        public ProfessorRepository(string connectionString)
        {
            _connectionString = connectionString;
        }

        public List<Professor> ObterTodosProfessores()
        {
            List<Professor> professores = new List<Professor>();
            using (var connection = new MySqlConnection(_connectionString))
            {
                connection.Open();
                string query = "SELECT * FROM professor";
                using (var command = new MySqlCommand(query, connection))
                using (var reader = command.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        professores.Add(new Professor
                        {
                            IdProfessor = reader.GetInt32("id_professor"),
                            Nome = reader.GetString("nome")
                        });
                    }
                }
            }
            return professores;
        }

        public int InserirProfessor(Professor professor)
        {
            int affectedRows = -1;
            using (var connection = new MySqlConnection(_connectionString))
            {
                connection.Open();
                string query = "INSERT INTO professor (nome) VALUES (@nome)";
                using (var command = new MySqlCommand(query, connection))
                {
                    command.Parameters.AddWithValue("@nome", professor.Nome);
                    affectedRows = command.ExecuteNonQuery();
                }
            }
            return affectedRows;
        }

        public int AtualizarProfessor(Professor professor)
        {
            int affectedRows = -1;
            using (var connection = new MySqlConnection(_connectionString))
            {
                connection.Open();
                string query = "UPDATE professor SET nome = @nome WHERE id_professor = @idProfessor";
                using (var command = new MySqlCommand(query, connection))
                {
                    command.Parameters.AddWithValue("@nome", professor.Nome);
                    command.Parameters.AddWithValue("@idProfessor", professor.IdProfessor);
                    affectedRows = command.ExecuteNonQuery();
                }
            }
            return affectedRows;
        }

        public int RemoverProfessor(int idProfessor)
        {
            int affectedRows = -1;
            using (var connection = new MySqlConnection(_connectionString))
            {
                connection.Open();
                string query = "DELETE FROM professor WHERE id_professor = @idProfessor";
                using (var command = new MySqlCommand(query, connection))
                {
                    command.Parameters.AddWithValue("@idProfessor", idProfessor);
                    affectedRows = command.ExecuteNonQuery();
                }
            }
            return affectedRows;
        }
    }
}
